import es
from mcolormsglib import mcolormsg

infos = es.AddonInfo()
infos.name = 'mcolormsg'
infos.basename = 'mcolormsg'
infos.version = '1.0'
infos.author = 'Matth'
infos.date = '25-06-2012'

es.ServerVar((infos.basename), infos.version + " by " + infos.author).makepublic()


MessageDict = {}

def load():
    if not es.exists('command', 'mcolormsg'):
        es.regcmd('mcolormsg', 'mcolormsg/mcolormsgCmd', 'Syntax:\n mcolormsg create <var> <0-255> <0-255> <0-255> <0-255> <message>\n mcolormsg concat <var> <0-255> <0-255> <0-255> <0-255> <message>\nSyntax:\n mcolormsg tell <var> <userid>\n mcolormsg <var> msg')

def mcolormsgCmd():
    count = es.getargc()
    if count < 3:
        es.dbgmsg(0, 'Syntax:\n mcolormsg create <var> <0-255> <0-255> <0-255> <0-255> <message>\n mcolormsg concat <var> <0-255> <0-255> <0-255> <0-255> <message>\nSyntax:\n mcolormsg tell <var> <userid>\n mcolormsg msg <var>')
    else:
        command = es.getargv(1)

        if command == "create":
            getvar = es.getargv(2)
            
            flags = ['%03i' %int(es.getargv(i)) for i in range(3, 7)]            
            lenght = len(''.join(str(es.getargv(i)) for i in range(1, 7))) + 6
            message = es.getargs()[lenght:]
            if not MessageDict.has_key(getvar):
                MessageDict[getvar] = mcolormsg(getvar)
            MessageDict[getvar].create(message, flags[0], flags[1], flags[2], flags[3])

        elif command == "concat":
            getvar = es.getargv(2)

            flags = ['%03i' %int(es.getargv(i)) for i in range(3, 7)]            
            lenght = len(''.join(str(es.getargv(i)) for i in range(1, 7))) + 6
            message = es.getargs()[lenght:]

            if MessageDict.has_key(getvar):
                MessageDict[getvar].concat(message, flags[0], flags[1], flags[2], flags[3])
            else:
                es.dbgmsg(0, "Error: '%s' doesn't exist" % getvar)

        elif command == "msg":
            getvar = es.getargv(2)
            if MessageDict.has_key(getvar):
                MessageDict[getvar].msg()
            else:
                es.dbgmsg(0, "Error: '%s' doesn't exist" % getvar)
    
                
        elif command == "tell":
            getvar = es.getargv(2)
            userid = es.getargs().split(' ')[2]
            if MessageDict.has_key(getvar):
                MessageDict[getvar].tell(userid)
            else:
                es.dbgmsg(0, "Error: '%s' doesn't exist" % getvar)
            
        else:
            es.dbgmsg(0, 'Syntax: mcolormsg msg <0-255> <0-255> <0-255> <0-255> <message>\nSyntax: mcolormsg tell <userid> <0-255> <0-255> <0-255> <0-255> <message>')
        
